/* Split-Radix FFT.h */
/* 2011.06.20, 10RU004, ΋ˑ */

#ifndef __Split_Radix_FFT__

	#define __Split_Radix_FFT__

	#ifndef _USE_MATH_DEFINES
		#define _USE_MATH_DEFINES
	#endif

	#include <math.h>

	/* t[Gϊ */
	void FFT(double *, long);
	void IFFT(double *, long);

	/* ֐ */
	void Rectangular(double *, long);
	void Hann(double *, long);
	void Hamming(double *, long);
	void Blackman(double *, long);
	void Bartlett(double *, long);
	void Bartlett_Hann(double *, long);
	void Nuttall(double *, long);
	void Blackman_Harris(double *, long);
	void Blackman_Nuttall(double *, long);
	void flat_top(double *, long);
	void Akaike(double *, long);
	void Welch(double *, long);

	/* tB^֐ */
	void HPF(double *, long, long, double);
	void LPF(double *, long, long, double);
	void BPF(double *, long, long, double);
	void BEF(double *, long, long, double);

#endif
